module Yao
  module Resources
    require "yao/resources/base"
    require "yao/resources/project_associationable"
    require "yao/resources/port_associationable"
    require "yao/resources/network_associationable"
    require "yao/resources/server_usage_associationable"

    autoload :Server,                    "yao/resources/server"
    autoload :ServerGroup,               "yao/resources/server_group"
    autoload :ServerMigrate,             "yao/resources/server_migrate"
    autoload :Flavor,                    "yao/resources/flavor"
    autoload :Image,                     "yao/resources/image"
    autoload :SecurityGroup,             "yao/resources/security_group"
    autoload :SecurityGroupRule,         "yao/resources/security_group_rule"
    autoload :Hypervisor,                "yao/resources/hypervisor"
    autoload :Aggregates,                "yao/resources/aggregates"
    autoload :Keypair,                   "yao/resources/keypair"
    autoload :FloatingIP,                "yao/resources/floating_ip"
    autoload :Network,                   "yao/resources/network"
    autoload :NetworkingAgents,          "yao/resources/networking_agents"
    autoload :Subnet,                    "yao/resources/subnet"
    autoload :Port,                      "yao/resources/port"
    autoload :Router,                    "yao/resources/router"
    autoload :LoadBalancer,              "yao/resources/loadbalancer"
    autoload :LoadBalancerListener,      "yao/resources/loadbalancer_listener"
    autoload :LoadBalancerPool,          "yao/resources/loadbalancer_pool"
    autoload :LoadBalancerPoolMember,    "yao/resources/loadbalancer_pool_member"
    autoload :LoadBalancerHealthMonitor, "yao/resources/loadbalancer_healthmonitor"
    autoload :Amphora,                   "yao/resources/amphora"
    autoload :Tenant,                    "yao/resources/tenant"
    autoload :Host,                      "yao/resources/host"
    autoload :User,                      "yao/resources/user"
    autoload :Role,                      "yao/resources/role"
    autoload :RoleAssignment,            "yao/resources/role_assignment"
    autoload :Volume,                    "yao/resources/volume"
    autoload :VolumeServices,            "yao/resources/volume_services"
    autoload :VolumeType,                "yao/resources/volume_type"
    autoload :ComputeServices,           "yao/resources/compute_services"
    autoload :Project,                   "yao/resources/project"

    autoload :Resource,                  "yao/resources/resource"
    autoload :Meter,                     "yao/resources/meter"
    autoload :OldSample,                 "yao/resources/old_sample"
    autoload :Sample,                    "yao/resources/sample"
  end

  # @param name [String]
  # @return [object]
  def self.const_missing(name)
    new_klass = Yao::Resources.const_get(name)
    Yao.const_set(name, new_klass)
  rescue NameError
    super
  end
end
